#include "Student.h"

Student::Student(const char* imie, const char* nazwisko, const char* kier, int nrI)
	:Osoba(imie,nazwisko),nrIndeksu(nrI)
{
	kierunek = new char[strlen(kier) + 1];
	strcpy(kierunek, kier);
	cout << "Konstruktor zwykly Studenta -> " << kierunek << ' ' << nrIndeksu << endl;
}

Student::~Student()
{
	cout << "Destruktor Studenta -> ";
	if (kierunek) cout << kierunek << ' ' << nrIndeksu << endl;

    //this->Osoba::~Osoba(); //Tak nie wolno
	delete[] kierunek;
	kierunek = nullptr;
}

Student::Student(const Student& wzor) :Osoba(wzor), nrIndeksu{wzor.nrIndeksu}
{
	kierunek = new char[strlen(wzor.kierunek) + 1];
	strcpy(kierunek, wzor.kierunek);
	cout << "Konstruktor Kopiujacy Student -> " << kierunek << ' ' << nrIndeksu << endl;
}

//Student& Student::operator=(const Student& wzor)
//{
//	if (&wzor != this)
//	{
//		this->~Student();
//		new(this)Student(wzor);
//	}
//	return *this;
//}

Student& Student::operator=(const Student& wzor)
{
	cout << "Operator= Student\n";

	if (&wzor != this)
	{
		delete[] kierunek;
		nrIndeksu = wzor.nrIndeksu;
		kierunek = new char[strlen(wzor.kierunek) + 1];
		strcpy(kierunek, wzor.kierunek);
		//Osoba::operator=(wzor);
		//(Osoba&)*this = wzor;
		static_cast<Osoba&>(*this) = wzor;

	}
	return *this;
}

Student::Student(Student&& wzor) noexcept: Osoba(std::move(wzor))
{
	kierunek = wzor.kierunek;
	nrIndeksu = wzor.nrIndeksu;
	wzor.kierunek = nullptr;
}

Student& Student::operator=(const Student&& wzor)
{
	if (this == &wzor) return *this;

	this->~Student();
	new(this)Student(std::move(wzor));

	return *this;
}
